//---------------------------------------------------------------------------

#ifndef mapunitH
#define mapunitH
//---------------------------------------------------------------------------

#include <Windows.hpp>
#include <SysUtils.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>

#include "util.h"
#include "tileunit.h"

#undef VAR
#undef INI
#ifdef mapunitCPP
#define VAR
#define INI(x) = x
#else
#define VAR extern
#define INI(x)
#endif

typedef Byte TMapArray[TILE_NUM_Y][TILE_NUM_X];

class TMap {
private:
  TMapArray FTerrMap, FItemMap; // aΤΪ~a

  int FLevelNo; // ثeJds
  Graphics::TBitmap* FInvBitmap; // Ω󪫫~zK

  int FRole_X, FRole_Y; // ⪺_lm

  void SetLevelNo(int Value);

  bool GetCanPass(int x, int y);
  bool GetIsTarget(int x, int y);

  bool GetCanMove(int x, int y);
  bool GetIsSource(int x, int y);

  TTerrAttr GetTerrAttr(int x, int y);
  void SetTerrAttr(int x, int y, TTerrAttr Value);
  TItemAttr GetItemAttr(int x, int y);
  void SetItemAttr(int x, int y, TItemAttr Value);

  Byte GetTerrMap(int x, int y);
  Byte GetItemMap(int x, int y);
  void SetTerrMap(int x, int y, Byte Value);
  void SetItemMap(int x, int y, Byte Value);
  void SetRole_X(int Value);
  void SetRole_Y(int Value);
protected:
public:
  TMap();
  ~TMap();

  AnsiString GetFileName(); // ھds, Ǧ^ɦW

  void LoadFromFile();
  void SaveToFile();

  void DrawTerrMap(TCanvas* Canvas); // Naεeb Canvas W
  void DrawItemMap(TCanvas* Canvas); // N~eb Canvas W

  // ]ia, Υu]aΩΪ~
  void ResetMap();
  void ResetTerrs();
  void ResetItems();

  __property int LevelNo = {read = FLevelNo, write = SetLevelNo};

  // oY檺aΤΪ~Ϥs
  __property Byte TerrMap[int x][int y] = {read = GetTerrMap, write = SetTerrMap};
  __property Byte ItemMap[int x][int y] = {read = GetItemMap, write = SetItemMap};

  // olm
  __property int Role_X = {read = FRole_X, write = SetRole_X};
  __property int Role_Y = {read = FRole_Y, write = SetRole_Y};

  // oY檺aݩ
  __property TTerrAttr TerrAttr[int x][int y] = {read = GetTerrAttr, write = SetTerrAttr};

  __property bool CanPass[int x][int y] = {read = GetCanPass};
  __property bool IsTarget[int x][int y] = {read = GetIsTarget};

  // oY檺~ݩ
  __property TItemAttr ItemAttr[int x][int y] = {read = GetItemAttr, write = SetItemAttr};

  __property bool CanMove[int x][int y] = {read = GetCanMove};
  __property bool IsSource[int x][int y] = {read = GetIsSource};
};

VAR TMap Map;

#endif
