//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "role.h"
#include "util.h"
#include "mapunit.h"

//---------------------------------------------------------------------------

TRole::TRole()
{
  FBits = new Graphics::TBitmap();

  FInvBitmap = new Graphics::TBitmap();
  FInvBitmap->Width = TILE_WIDTH;
  FInvBitmap->Height = TILE_HEIGHT;
  FInvBitmap->Transparent = true;
  FInvBitmap->TransparentColor = (TColor)RGB(128, 0, 0);
}

TRole::~TRole()
{
  delete FInvBitmap;
  delete FBits;
}

void TRole::LoadBits()
{
  FBits->LoadFromFile(FN_ROLEBITS); // Ū BMP , t|ӤVϧ

  if (FBits->Width < TILE_WIDTH * 4) // |ӤV
    throw Exception("Width of role bits is invalid");

  FInvBitmap->PixelFormat = FBits->PixelFormat; // Τ@ FInvBitmap  FBits 榡
}

void TRole::Draw(TCanvas* Canvas)
{
  // NnqXϰ FInvBitmap, AeX FInvBitmap
  FInvBitmap->Canvas->CopyRect(Rect(0, 0, TILE_WIDTH, TILE_HEIGHT), FBits->Canvas, Rect((int)FDirection * TILE_WIDTH, 0,
    ((int)Direction + 1) * TILE_WIDTH, TILE_HEIGHT));

  // ѨM VCL b Windows 98 UzK bug  workaround
  if (IsWindows98())
    DrawTransparentBitmap(Canvas->Handle, FInvBitmap->Handle, FX * TILE_WIDTH, FY * TILE_HEIGHT, RGB(128, 0, 0));
  else
    Canvas->Draw(FX * TILE_WIDTH, FY * TILE_HEIGHT, FInvBitmap);
}

// small but useful function, update x & y location of role
void MoveAhead(int& X, int& Y, TDirection Dir)
{
  switch (Dir) {
    case drUp: Y--; break;
    case drDown: Y++; break;
    case drLeft: X--; break;
    case drRight: X++; break;
  }
}

void TRole::Move(TDirection Dir)
{
  int X, Y, MX, MY;

  X = FX; Y = FY;
  MoveAhead(X, Y, Dir); // p⨤⪺U@m
  FDirection = Dir;

  // WXedF...
  if (Y < 0 || X < 0 || X >= TILE_NUM_X || Y >= TILE_NUM_Y) return;

  if (!Map.CanPass[X][Y]) return; // ਫa

  if (Map.ItemMap[X][Y] != 0) { // pGnʹLhm~
    if (!Map.CanMove[X][Y]) return; // hʭC

    MX = X; MY = Y;
    MoveAhead(MX, MY, Dir); // p⪫~sm
    if (MY < 0 || MX < 0 || MX >= TILE_NUM_X || MY >= TILE_NUM_Y) return; // iN~d~

    // nhLhsmW঳F, ]OiHʪa
    if (Map.ItemMap[MX][MY] != 0 || !Map.CanPass[MX][MY]) return;

    Map.ItemMap[MX][MY] = Map.ItemMap[X][Y]; // hʹLh
    Map.ItemMap[X][Y] = 0; // ӪaS~F
  }
  
  // \X, NʤVOU
  FMoveList.push_back(Dir);
  
  FX = X; // sm
  FY = Y;
}

void TRole::SavePlayBack()
{
  // NʰO FPlayBackList , HK
  FPlayBackList = FMoveList;
}

void TRole::CleanMoveList()
{
  FMoveList.clear(); // ʰOMHKUϥ
}

#pragma package(smart_init)
