//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "about.h"
#include "kinddlg.h"
#include "util.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::mnuExitClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuAboutClick(TObject *Sender)
{
  TAboutBox* box = new TAboutBox(this);
  try {
    box->ShowModal();
  } __finally {
    delete box;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuNewClick(TObject *Sender)
{
  // إ߸߰ݹܲ
  TTileKindDlg* dlg = new TTileKindDlg(this);
  try {
    // qXܲ, ϥΪ̫U"Tw"|Ǧ^ mrOK
    if (dlg->ShowModal() == mrOk) {
      if (dlg->rgpTileKind->ItemIndex == 0)
        CreateTiles(typeid(TTerrTiles));    // aιϮw
      else
        CreateTiles(typeid(TItemTiles));   // ~Ϯw

      FOldSelection = -1;
      UpdateControlStatus();
    }
  } __finally {
    delete dlg; // Lצp, R߰ݹܲ
  }
}
//---------------------------------------------------------------------------
#define MAX(a, b) ((a)>(b)?(a):(b))

void __fastcall TMainForm::UpdateControlStatus()
{
  AnsiString TileKindStr[2] = {"Terrain", "Items"};

  // update caption
  AnsiString sFileName = FFileName;
  if (sFileName == "") sFileName = "Untitled";
  Caption = Format("%s - %s", OPENARRAY(TVarRec, (Application->Title,
    ExtractFileName(sFileName))));

  int TileKind = dynamic_cast<TTerrTiles*>(FTiles) ? 0 : 1;
  nbkTileAttr->PageIndex = TileKind;
  lblTileKind->Caption = TileKindStr[TileKind];
  lblTileNum->Caption = IntToStr(FTiles->TileNum);

  mnuSave->Enabled = FTiles->TileNum != 0;
  mnuSaveAs->Enabled = FTiles->TileNum != 0;

  grdPreview->RowCount = MAX(10, FTiles->TileRowCount);
  grdPreview->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreateTiles(const std::type_info& typeinfo)
{
  if (FTiles) delete FTiles;

  if (typeinfo == typeid(TTerrTiles))
    FTiles = new TTerrTiles();
  else if (typeinfo == typeid(TItemTiles))
    FTiles = new TItemTiles();
  else // OwO
    throw Exception("Invalid class type info");
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuOpenClick(TObject *Sender)
{
  if (dlgOpen->Execute()) {
    try {
      CreateTiles(typeid(TTerrTiles)); // ոլݬO_aιϮw
      // Ū, N|ͨҥ~, ڭ̪ҥ~ɮBz(catch (...) block)
      FTiles->LoadFromFile(dlgOpen->FileName);
      FFileName = dlgOpen->FileName; // ŪaιϮw\
    } catch (...) {
      // pGOaιϮw, ˬdYҮɷ|ͨҥ~, ҥHoӰ
      CreateTiles(typeid(TItemTiles)); // AոլݬO_~Ϯw, _hN򳣤O
      // , ]|ͨҥ~, ڭ̴NBzF
      FTiles->LoadFromFile(dlgOpen->FileName);
      FFileName = dlgOpen->FileName;
    }

    FOldSelection = -1;
    UpdateControlStatus();
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuSaveClick(TObject *Sender)
{
  // YO"tss" ٥wɦW, NݨϥΪɦW
  if (dynamic_cast<TComponent*>(Sender)->Tag == 1 || FFileName == "") {
    dlgSave->Filter = dlgOpen->Filter;
    if (!dlgSave->Execute()) return; // ߰ݨϥΪɦW, YN}
    FFileName = dlgSave->FileName; // NɦWO_
  }

  FTiles->SaveToFile(FFileName); // xsϮw
  UpdateControlStatus(); // sD
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuImportClick(TObject *Sender)
{
  // פJ BMP ϧ
  if (dlgOpenPicture->Execute()) {
    FTiles->ImportPicture(dlgOpenPicture->FileName);
    UpdateControlStatus();
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::grdPreviewDrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
  int No = ARow * grdPreview->ColCount + ACol; // ѦΦCϤs

  if (No < FTiles->TileNum) // NϧεeX
    BitBlt(grdPreview->Canvas->Handle, Rect.Left, Rect.Top, TILE_WIDTH, TILE_HEIGHT,
    FTiles->Bitmap->Canvas->Handle, FTiles->TilePos_Left[No], FTiles->TilePos_Top[No], SRCCOPY);
  else {
    grdPreview->Canvas->Brush->Color = clBlack; // sjϤƥ
    grdPreview->Canvas->FillRect(Rect);
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::grdPreviewSelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
  int No, OldNo = FOldSelection;

  // OldNo 쥻ܪϤs
  if (OldNo < FTiles->TileNum) { // NϥΪ̳]wϤݩʼg^h
    // YOaιϮw...
    if (TTerrTiles* TerrTiles = dynamic_cast<TTerrTiles*>(FTiles)) {
      TTerrAttr& Attr = TerrTiles->Attrs[OldNo];
      // ھ cbxCanPass  cbxTarget  checkbox ӳ]wϤݩ
      Attr = TTerrAttr();

      // iHVa
      if (cbxCanPass->Checked) Attr = Attr << taCanPass;
      // Oتa
      if (cbxTarget->Checked) Attr = Attr << taTarget;
    } else if (TItemTiles* ItemTiles = dynamic_cast<TItemTiles*>(FTiles)) {
      // YO~Ϯw...
      TItemAttr& Attr = ItemTiles->Attrs[OldNo];
      Attr = TItemAttr();

      // iHhʪ~
      if (cbxCanMove->Checked) Attr = Attr << iaCanMove;
      // л\Ϊ~
      if (cbxSource->Checked) Attr = Attr << iaSource;
    }
  }

  No = ARow * grdPreview->ColCount + ACol; // pYNܪϤs
  if (No < FTiles->TileNum) { // qXثeҿ諸Ϥݩ
    lblTileNo->Caption = "s: " + IntToStr(No);

    // NҿܪϤݩʥ checkbox {X
    if (TTerrTiles* TerrTiles = dynamic_cast<TTerrTiles*>(FTiles)) {
      TTerrAttr& Attr = TerrTiles->Attrs[No];
      cbxCanPass->Checked = Attr.Contains(taCanPass);
      cbxTarget->Checked = Attr.Contains(taTarget);
    } else if (TItemTiles* ItemTiles = dynamic_cast<TItemTiles*>(FTiles)) {
      TItemAttr& Attr = ItemTiles->Attrs[No];
      cbxCanMove->Checked = Attr.Contains(iaCanMove);
      cbxSource->Checked = Attr.Contains(iaSource);
    }

    // sܪ tile no
    FOldSelection = No;
  } else
    CanSelect = false; // ܤXkϮ, 
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  CreateTiles(typeid(TTerrTiles)); // w]aιϮw
  grdPreview->ColCount = FTiles->TileNumPerRow;

  UpdateControlStatus();
}
//---------------------------------------------------------------------------

