//---------------------------------------------------------------------------

#ifndef tileunitH
#define tileunitH
//---------------------------------------------------------------------------

#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Graphics.hpp>

#include <vector>

#undef VAR
#undef INI
#ifdef tileunitCPP
#define VAR
#define INI(x) = x
#else
#define VAR extern
#define INI(x)
#endif

// aΪݩ
typedef enum {taCanPass, taTarget} TTerrAttrElement;
typedef Set<TTerrAttrElement, taCanPass, taTarget> TTerrAttr;

// ~ݩ
typedef enum {iaCanMove, iaSource} TItemAttrElement;
typedef Set<TItemAttrElement, iaCanMove, iaSource> TItemAttr;

class TTiles {
private:
  Graphics::TBitmap* FBits; // sϮwҦϤ bitmap
  int FTileNum; // Ϥƶq

  int GetTilePos_Left(int index);
  int GetTilePos_Top(int index);

  int GetTileNumPerRow();
  int GetTileRowCount();
protected:
  virtual void SetTileNum(int Value);

  // Ūγ]wݩʳOk, NOӧg
  virtual void LoadAttrs(TReader* filer) = 0;
  virtual void WriteAttrs(TWriter* filer) = 0;
public:
  TTiles();
  virtual ~TTiles();

  // JxsϮw
  void LoadFromFile(AnsiString Filename);
  void SaveToFile(AnsiString Filename);

  void ImportPicture(AnsiString Filename); // פJϧ

  __property int TileNum = {read = FTileNum, write = SetTileNum};

  __property int TileNumPerRow = {read = GetTileNumPerRow}; // CCϤƥ
  __property int TileRowCount = {read = GetTileRowCount}; // @XCϤ

  __property Graphics::TBitmap* Bitmap = {read = FBits};

  // ھڹϤsNioϤbϧΤm
  __property int TilePos_Left[int index] = {read = GetTilePos_Left};
  __property int TilePos_Top[int index] = {read = GetTilePos_Top};
};

class TTerrTiles : public TTiles {
private:
  std::vector<TTerrAttr> FAttrs;
  TTerrAttr& GetAttrs(int index);
  void SetAttrs(int index, const TTerrAttr& Value);
protected:
  virtual void SetTileNum(int Value);

  virtual void LoadAttrs(TReader* filer);
  virtual void WriteAttrs(TWriter* filer);
public:
  __property TTerrAttr Attrs[int index] = {read = GetAttrs, write = SetAttrs};
};

class TItemTiles : public TTiles {
private:
  std::vector<TItemAttr> FAttrs;
  TItemAttr& GetAttrs(int index);
  void SetAttrs(int index, const TItemAttr& Value);
protected:
  virtual void SetTileNum(int Value);

  virtual void LoadAttrs(TReader* filer);
  virtual void WriteAttrs(TWriter* filer);
public:
  __property TItemAttr Attrs[int index] = {read = GetAttrs, write = SetAttrs};
};

VAR TTerrTiles Terrs;
VAR TItemTiles Items;

#endif
